<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>library_dir_dir/system_library_tools/source/bound_bcpl_.s.archive/bcpl_cg1.bcpl</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="c">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.Statement { color: #afd700; }
.Repeat { color: #af87d7; font-weight: bold; }
.LineNr { color: #585858; }
.String { color: #d7af5f; }
.Conditional { color: #af87d7; font-weight: bold; }
.Number { color: #ff5faf; }
.Comment { color: #808080; }
.Constant { color: #ff5faf; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="Comment">//  Arithmetic sequences are generated by these routines.</span>
<span id="L2" class="LineNr">  2 </span><span class="Comment">//  Last modified on 06/06/74 at 18:21:22 by R F Mabee.</span>
<span id="L3" class="LineNr">  3 </span><span class="Comment">//  First installed as Version 3.4 by R F Mabee.</span>
<span id="L4" class="LineNr">  4 </span><span class="Comment">//  Written in April 1973 to properly divide the work between Trans and CG.</span>
<span id="L5" class="LineNr">  5 </span>
<span id="L6" class="LineNr">  6 </span><span class="Comment">//  Copyright (c) 1974 by Massachusetts Institute of Technology and Honeywell Information Systems, Inc.</span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span><span class="Comment">//  General permission is granted to copy and use this program, but not to sell it, provided that the above</span>
<span id="L9" class="LineNr">  9 </span><span class="Comment">//  copyright statement is given.  Contact Information Processing Services, MIT, for further information.</span>
<span id="L10" class="LineNr"> 10 </span><span class="Comment">//  Please contact R F Mabee at MIT for information on this program and versions for other machines.</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>get <span class="String">&quot;bcpl_cg_head&quot;</span>
<span id="L13" class="LineNr"> 13 </span>get <span class="String">&quot;bcpl_opcodes&quot;</span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>let ApplyDiadicOperator (Op, Result) be
<span id="L16" class="LineNr"> 16 </span>     $(   let Reg = valof switchon Op into
<span id="L17" class="LineNr"> 17 </span>               $(   case PLUS_S:
<span id="L18" class="LineNr"> 18 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryDiadicRAR (Result, Asa) resultis <span class="Number">0</span>
<span id="L19" class="LineNr"> 19 </span>                              resultis ApplySymmetrical (Ada, AorQr)
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>                    case PLUS_F:
<span id="L22" class="LineNr"> 22 </span>                              resultis ApplySymmetrical (Fad, EAQr)
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>                    case MINUS_S:
<span id="L25" class="LineNr"> 25 </span>                              <span class="Conditional">if</span> Optimize <span class="Repeat">do</span>
<span id="L26" class="LineNr"> 26 </span>                                   $(   <span class="Conditional">if</span> TryDiadicRAR (Result, Ssa) resultis <span class="Number">0</span>
<span id="L27" class="LineNr"> 27 </span>                                        <span class="Conditional">if</span> InRegister (Rrand, AorQr) &amp; not InRegister (Lrand, AorQr) <span class="Repeat">do</span>
<span id="L28" class="LineNr"> 28 </span>                                             $(   let r = ApplyRL (Sba, AorQr)
<span id="L29" class="LineNr"> 29 </span>                                                  resultis ApplyNegate (r)
<span id="L30" class="LineNr"> 30 </span>                                             $)
<span id="L31" class="LineNr"> 31 </span>                                   $)
<span id="L32" class="LineNr"> 32 </span>                              resultis ApplyLR (Sba, AorQr)
<span id="L33" class="LineNr"> 33 </span>
<span id="L34" class="LineNr"> 34 </span>                    case MINUS_F:
<span id="L35" class="LineNr"> 35 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> InRegister (Rrand, EAQr) <span class="Repeat">do</span>
<span id="L36" class="LineNr"> 36 </span>                                             $(   ApplyRL (Fsb, EAQr)
<span id="L37" class="LineNr"> 37 </span>                                                  resultis ApplyNegate (EAQr)
<span id="L38" class="LineNr"> 38 </span>                                             $)
<span id="L39" class="LineNr"> 39 </span>                              resultis ApplyLR (Fsb, EAQr)
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span>                    case MULT_S:
<span id="L42" class="LineNr"> 42 </span>                              <span class="Conditional">if</span> Optimize <span class="Repeat">do</span>
<span id="L43" class="LineNr"> 43 </span>                                   $(   let r = TryShift (Lrand, Rrand)
<span id="L44" class="LineNr"> 44 </span>                                        <span class="Conditional">if</span> r ne <span class="Number">0</span> resultis r
<span id="L45" class="LineNr"> 45 </span>                                        r := TryShift (Rrand, Lrand)
<span id="L46" class="LineNr"> 46 </span>                                        <span class="Conditional">if</span> r ne <span class="Number">0</span> resultis r
<span id="L47" class="LineNr"> 47 </span>                                        <span class="Conditional">if</span> (InRegister (Lrand, Ar) &amp; not InRegister (Rrand, Qr))
<span id="L48" class="LineNr"> 48 </span>                                           | (InRegister (Rrand, Ar) &amp; not InRegister (Lrand, Qr)) <span class="Repeat">do</span> SwapAandQ ()
<span id="L49" class="LineNr"> 49 </span>                                   $)
<span id="L50" class="LineNr"> 50 </span>                              GetRegister (Ar)              <span class="Comment">//  Overwritten by multiply hardware.</span>
<span id="L51" class="LineNr"> 51 </span>                              resultis ApplySymmetrical (Mpy, Qr)
<span id="L52" class="LineNr"> 52 </span>
<span id="L53" class="LineNr"> 53 </span>                    case MULT_F:
<span id="L54" class="LineNr"> 54 </span>                              resultis ApplySymmetrical (Fmp, EAQr)
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>                    case DIV_S:
<span id="L57" class="LineNr"> 57 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> InRegister (Lrand, Ar) <span class="Repeat">do</span> SwapAandQ ()
<span id="L58" class="LineNr"> 58 </span>                              GetRegister (Ar)              <span class="Comment">//  Overwritten by divide hardware.</span>
<span id="L59" class="LineNr"> 59 </span>                              resultis ApplyLR (Div, Qr)
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>                    case DIV_F:
<span id="L62" class="LineNr"> 62 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> InRegister (Rrand, EAQr) <span class="Repeat">do</span>
<span id="L63" class="LineNr"> 63 </span>                                        resultis ApplyRL (Fdi, EAQr)
<span id="L64" class="LineNr"> 64 </span>                              resultis ApplyLR (Fdv, EAQr)
<span id="L65" class="LineNr"> 65 </span>
<span id="L66" class="LineNr"> 66 </span>                    case REM_S:
<span id="L67" class="LineNr"> 67 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> InRegister (Lrand, Ar) <span class="Repeat">do</span> SwapAandQ ()
<span id="L68" class="LineNr"> 68 </span>                              GetRegister (Ar)              <span class="Comment">//  Remainder appears in Ar but operands do not.</span>
<span id="L69" class="LineNr"> 69 </span>                              ApplyLR (Div, Qr)
<span id="L70" class="LineNr"> 70 </span>                              resultis Ar
<span id="L71" class="LineNr"> 71 </span>
<span id="L72" class="LineNr"> 72 </span>                    case LOGOR_S:
<span id="L73" class="LineNr"> 73 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryDiadicRAR (Result, Orsa) resultis <span class="Number">0</span>
<span id="L74" class="LineNr"> 74 </span>                              resultis ApplySymmetrical (Ora, AorQr)
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>                    case LOGAND_S:
<span id="L77" class="LineNr"> 77 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryDiadicRAR (Result, Ansa) resultis <span class="Number">0</span>
<span id="L78" class="LineNr"> 78 </span>                              resultis ApplySymmetrical (Ana, AorQr)
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>                    case NEQV_S:
<span id="L81" class="LineNr"> 81 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryDiadicRAR (Result, Ersa) resultis <span class="Number">0</span>
<span id="L82" class="LineNr"> 82 </span>                              resultis ApplySymmetrical (Era, AorQr)
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>                    case EQV_S:    $(   let r = ApplySymmetrical (Era, AorQr)
<span id="L85" class="LineNr"> 85 </span>                                        Literal (<span class="Constant">true</span>, <span class="String">&quot;true&quot;</span>)
<span id="L86" class="LineNr"> 86 </span>                                        Outop (FormOpcode (Era, r))
<span id="L87" class="LineNr"> 87 </span>                                        resultis r
<span id="L88" class="LineNr"> 88 </span>                                   $)
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>                    <span class="Constant">default</span>:  CGreport (UnexpectedCase, Op, <span class="String">&quot;ApplyDiadicOperator&quot;</span>)
<span id="L91" class="LineNr"> 91 </span>                              resultis <span class="Number">0</span>
<span id="L92" class="LineNr"> 92 </span>               $)
<span id="L93" class="LineNr"> 93 </span>          DisclaimRegister (Lrand)
<span id="L94" class="LineNr"> 94 </span>          DisclaimRegister (Rrand)
<span id="L95" class="LineNr"> 95 </span>          ClaimRegister (Reg, Result)
<span id="L96" class="LineNr"> 96 </span>     $)
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span><span class="Statement">and</span> ApplyOffsetOperator (Op, Result, Offset) be
<span id="L99" class="LineNr"> 99 </span>     $(   let Reg = valof switchon Op into
<span id="L100" class="LineNr">100 </span>               $(   case VECAP_S:
<span id="L101" class="LineNr">101 </span>                              <span class="Conditional">if</span> Result!<span class="Number">0</span> = LV_TEMP goto RememberAddress
<span id="L102" class="LineNr">102 </span>                              let r = GetRegister (AorQr)
<span id="L103" class="LineNr">103 </span>                              CombineAddress (Lrand, Rrand, Offset)
<span id="L104" class="LineNr">104 </span>                              Outop (FormOpcode (Lda, r))
<span id="L105" class="LineNr">105 </span>                              IndicatorsSetBy := r
<span id="L106" class="LineNr">106 </span>                              resultis r
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>                    case LVECAP_S:
<span id="L109" class="LineNr">109 </span>                              <span class="Conditional">if</span> Result!<span class="Number">0</span> = LV_TEMP goto RememberAddress
<span id="L110" class="LineNr">110 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> IsSameLoc (Result, Lrand) <span class="Repeat">do</span>
<span id="L111" class="LineNr">111 </span>                                   $(   let r = nil
<span id="L112" class="LineNr">112 </span>                                        test IsZero (Rrand)
<span id="L113" class="LineNr">113 </span>                                        then $(   <span class="Conditional">if</span> Offset = <span class="Number">1</span> <span class="Repeat">do</span>
<span id="L114" class="LineNr">114 </span>                                                       $(   SetupAddr (Result)
<span id="L115" class="LineNr">115 </span>                                                            Outop (Aos)
<span id="L116" class="LineNr">116 </span>                                                            IndicatorsSetBy := <span class="Number">0</span>
<span id="L117" class="LineNr">117 </span>                                                            resultis <span class="Number">0</span>
<span id="L118" class="LineNr">118 </span>                                                       $)
<span id="L119" class="LineNr">119 </span>                                                  r := LoadNumber (Offset, AorQr)
<span id="L120" class="LineNr">120 </span>                                             $)
<span id="L121" class="LineNr">121 </span>                                        or   $(   r := LoadRegister (Rrand, AorQr)
<span id="L122" class="LineNr">122 </span>                                                  unless Offset = <span class="Number">0</span> <span class="Repeat">do</span>
<span id="L123" class="LineNr">123 </span>                                                       $(   Literal (Offset)
<span id="L124" class="LineNr">124 </span>                                                            Outop (FormOpcode (Ada, r))
<span id="L125" class="LineNr">125 </span>                                                       $)
<span id="L126" class="LineNr">126 </span>                                             $)
<span id="L127" class="LineNr">127 </span>                                        SetupAddr (Result)
<span id="L128" class="LineNr">128 </span>                                        Outop (FormOpcode (Asa, r))
<span id="L129" class="LineNr">129 </span>                                        IndicatorsSetBy := <span class="Number">0</span>
<span id="L130" class="LineNr">130 </span>                                        RegisterUsage!r := <span class="Number">0</span>
<span id="L131" class="LineNr">131 </span>                                        resultis <span class="Number">0</span>
<span id="L132" class="LineNr">132 </span>                                   $)
<span id="L133" class="LineNr">133 </span>                              r := GetRegister (AnyPr)
<span id="L134" class="LineNr">134 </span>                              CombineAddress (Lrand, Rrand, Offset)
<span id="L135" class="LineNr">135 </span>                              Outop (FormOpcode (Eapap, r))
<span id="L136" class="LineNr">136 </span>                              resultis r
<span id="L137" class="LineNr">137 </span>
<span id="L138" class="LineNr">138 </span>                    RememberAddress:
<span id="L139" class="LineNr">139 </span>                              let h = MakeCgTemp (Result!<span class="Number">1</span>)
<span id="L140" class="LineNr">140 </span>                              h!<span class="Number">1</span> := Op
<span id="L141" class="LineNr">141 </span>                              h!<span class="Number">2</span>, h!<span class="Number">3</span>, h!<span class="Number">4</span> := Lrand!<span class="Number">0</span>, Lrand!<span class="Number">1</span>, Lrand!<span class="Number">2</span>
<span id="L142" class="LineNr">142 </span>                              h!<span class="Number">5</span>, h!<span class="Number">6</span>, h!<span class="Number">7</span> := Rrand!<span class="Number">0</span>, Rrand!<span class="Number">1</span>, Rrand!<span class="Number">2</span>
<span id="L143" class="LineNr">143 </span>                              h!<span class="Number">8</span> := Offset
<span id="L144" class="LineNr">144 </span>                              <span class="Statement">return</span>
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>                    case LSHIFT_S:
<span id="L147" class="LineNr">147 </span>                    case RSHIFT_S:
<span id="L148" class="LineNr">148 </span>                                   $(   let r = LoadRegister (Lrand, AorQr)
<span id="L149" class="LineNr">149 </span>                                        let Xr = IsZero (Rrand) -&gt; <span class="Number">0</span>, LoadIndex (Rrand, AnyXr)
<span id="L150" class="LineNr">150 </span>                                        Outop3 (FormOpcode (Op = LSHIFT_S -&gt; Als, Arl, r), Offset, FormTag (Xr))
<span id="L151" class="LineNr">151 </span>                                        IndicatorsSetBy := r
<span id="L152" class="LineNr">152 </span>                                        resultis r
<span id="L153" class="LineNr">153 </span>                                   $)
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>                    <span class="Constant">default</span>:  CGreport (UnexpectedCase, Op, <span class="String">&quot;ApplyAddressOperator&quot;</span>)
<span id="L156" class="LineNr">156 </span>                              resultis <span class="Number">0</span>
<span id="L157" class="LineNr">157 </span>               $)
<span id="L158" class="LineNr">158 </span>          DisclaimRegister (Lrand)
<span id="L159" class="LineNr">159 </span>          DisclaimRegister (Rrand)
<span id="L160" class="LineNr">160 </span>          ClaimRegister (Reg, Result)
<span id="L161" class="LineNr">161 </span>     $)
<span id="L162" class="LineNr">162 </span>
<span id="L163" class="LineNr">163 </span><span class="Statement">and</span> ApplyMonadicOperator (Op, Result) be
<span id="L164" class="LineNr">164 </span>     $(   let Reg = valof switchon Op into
<span id="L165" class="LineNr">165 </span>               $(   case POS_S:
<span id="L166" class="LineNr">166 </span>                    case POS_F:
<span id="L167" class="LineNr">167 </span>                    case ASSIGN_S:
<span id="L168" class="LineNr">168 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> Result!<span class="Number">0</span> ne LV_TEMP <span class="Repeat">do</span>
<span id="L169" class="LineNr">169 </span>                                   $(   Store (Lrand, Result)
<span id="L170" class="LineNr">170 </span>                                        resultis <span class="Number">0</span>
<span id="L171" class="LineNr">171 </span>                                   $)
<span id="L172" class="LineNr">172 </span>                              resultis LoadAppropriateRegister (Lrand, <span class="Number">0</span>)
<span id="L173" class="LineNr">173 </span>
<span id="L174" class="LineNr">174 </span>                    case NEG_S:
<span id="L175" class="LineNr">175 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryMonadicRAR (Result, Ssa, <span class="Number">0</span>) resultis <span class="Number">0</span>
<span id="L176" class="LineNr">176 </span>                              resultis LoadNegative (Lrand)
<span id="L177" class="LineNr">177 </span>
<span id="L178" class="LineNr">178 </span>                    case NEG_F:
<span id="L179" class="LineNr">179 </span>                              resultis ApplyNegate (LoadRegister (Lrand, EAQr))
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>                    case NOT_S:
<span id="L182" class="LineNr">182 </span>                              <span class="Conditional">if</span> Optimize then <span class="Conditional">if</span> TryMonadicRAR (Result, Ersa, <span class="Constant">true</span>) resultis <span class="Number">0</span>
<span id="L183" class="LineNr">183 </span>                              let r = FindInRegister (Lrand, AorQr)
<span id="L184" class="LineNr">184 </span>                              test r = <span class="Number">0</span>
<span id="L185" class="LineNr">185 </span>                              then $(   r := LoadNumber (<span class="Constant">true</span>, AorQr, <span class="String">&quot;true&quot;</span>)
<span id="L186" class="LineNr">186 </span>                                        Makeaddressable (Lrand)
<span id="L187" class="LineNr">187 </span>                                   $)
<span id="L188" class="LineNr">188 </span>                              or Literal (<span class="Constant">true</span>, <span class="String">&quot;true&quot;</span>)
<span id="L189" class="LineNr">189 </span>                              Outop (FormOpcode (Era, r))
<span id="L190" class="LineNr">190 </span>                              IndicatorsSetBy := r
<span id="L191" class="LineNr">191 </span>                              resultis r
<span id="L192" class="LineNr">192 </span>
<span id="L193" class="LineNr">193 </span>                    <span class="Constant">default</span>:  CGreport (UnexpectedCase, Op, <span class="String">&quot;ApplyMonadicOperator&quot;</span>)
<span id="L194" class="LineNr">194 </span>                              resultis <span class="Number">0</span>
<span id="L195" class="LineNr">195 </span>               $)
<span id="L196" class="LineNr">196 </span>          DisclaimRegister (Lrand)
<span id="L197" class="LineNr">197 </span>          ClaimRegister (Reg, Result)
<span id="L198" class="LineNr">198 </span>     $)
<span id="L199" class="LineNr">199 </span>
<span id="L200" class="LineNr">200 </span><span class="Statement">and</span> ApplySymmetrical (Inst, Reg) = InRegister (Rrand, Reg) -&gt; ApplyRL (Inst, Reg), ApplyLR (Inst, Reg)
<span id="L201" class="LineNr">201 </span><span class="Statement">and</span> ApplyRL (Inst, Reg) = valof
<span id="L202" class="LineNr">202 </span>     $(   let t, u = Lrand, Rrand
<span id="L203" class="LineNr">203 </span>          Rrand, Lrand := t, u
<span id="L204" class="LineNr">204 </span>          let r = ApplyLR (Inst, Reg)
<span id="L205" class="LineNr">205 </span>          Lrand, Rrand := t, u
<span id="L206" class="LineNr">206 </span>          resultis r
<span id="L207" class="LineNr">207 </span>     $)
<span id="L208" class="LineNr">208 </span><span class="Statement">and</span> ApplyLR (Inst, Reg) = valof
<span id="L209" class="LineNr">209 </span>     $(   let r = LoadRegister (Lrand, Reg)
<span id="L210" class="LineNr">210 </span>          Makeaddressable (Rrand)
<span id="L211" class="LineNr">211 </span>          Outop (FormOpcode (Inst, r))
<span id="L212" class="LineNr">212 </span>          IndicatorsSetBy := r
<span id="L213" class="LineNr">213 </span>          resultis r
<span id="L214" class="LineNr">214 </span>     $)
<span id="L215" class="LineNr">215 </span><span class="Statement">and</span> ApplyNegate (r) = valof
<span id="L216" class="LineNr">216 </span>  switchon r into
<span id="L217" class="LineNr">217 </span>     $(   case Qr:  <span class="Conditional">if</span> RegisterTemps!Ar = <span class="Number">0</span> <span class="Repeat">do</span>
<span id="L218" class="LineNr">218 </span>                         $(   Outop3 (Negl, <span class="Number">0</span>, Dl)
<span id="L219" class="LineNr">219 </span>                              IndicatorsSetBy := <span class="Number">0</span>
<span id="L220" class="LineNr">220 </span>                              resultis Qr
<span id="L221" class="LineNr">221 </span>                         $)
<span id="L222" class="LineNr">222 </span>                    SwapAandQ ()
<span id="L223" class="LineNr">223 </span>          case Ar:  Outop3 (Neg, <span class="Number">0</span>, Dl)
<span id="L224" class="LineNr">224 </span>                    IndicatorsSetBy := Ar
<span id="L225" class="LineNr">225 </span>                    resultis Ar
<span id="L226" class="LineNr">226 </span>          case EAQr:Outop3 (Fneg, <span class="Number">0</span>, Dl)
<span id="L227" class="LineNr">227 </span>                    IndicatorsSetBy := EAQr
<span id="L228" class="LineNr">228 </span>                    resultis EAQr
<span id="L229" class="LineNr">229 </span>          <span class="Constant">default</span>:  CGreport (UnexpectedCase, r, <span class="String">&quot;ApplyNegate&quot;</span>)
<span id="L230" class="LineNr">230 </span>                    resultis r
<span id="L231" class="LineNr">231 </span>     $)
<span id="L232" class="LineNr">232 </span><span class="Statement">and</span> LoadNegative (t) = valof
<span id="L233" class="LineNr">233 </span>     $(   let r = FindInRegister (t, AorQr)
<span id="L234" class="LineNr">234 </span>          <span class="Conditional">if</span> r ne <span class="Number">0</span> resultis ApplyNegate (r)
<span id="L235" class="LineNr">235 </span>          r := GetRegister (AorQr)
<span id="L236" class="LineNr">236 </span>          Makeaddressable (t)
<span id="L237" class="LineNr">237 </span>          Outop (FormOpcode (Lca, r))
<span id="L238" class="LineNr">238 </span>          IndicatorsSetBy := r
<span id="L239" class="LineNr">239 </span>          resultis r
<span id="L240" class="LineNr">240 </span>     $)
<span id="L241" class="LineNr">241 </span>
<span id="L242" class="LineNr">242 </span><span class="Statement">and</span> TryShift (Rand, Const) = valof
<span id="L243" class="LineNr">243 </span>     $(   unless IsNumber (Const) resultis <span class="Number">0</span>
<span id="L244" class="LineNr">244 </span>          let n, i = EvalNumber (Const!<span class="Number">0</span>, Const!<span class="Number">1</span>), <span class="Number">0</span>
<span id="L245" class="LineNr">245 </span>          until n = (<span class="Number">1</span> lshift i) <span class="Repeat">do</span>
<span id="L246" class="LineNr">246 </span>               $(   <span class="Conditional">if</span> i &gt; <span class="Number">36</span> resultis <span class="Number">0</span>
<span id="L247" class="LineNr">247 </span>                    i := i + <span class="Number">1</span>
<span id="L248" class="LineNr">248 </span>               $)
<span id="L249" class="LineNr">249 </span>          let r = LoadRegister (Rand, AorQr)
<span id="L250" class="LineNr">250 </span>          Outop3 (FormOpcode (Als, r), i, <span class="Number">0</span>)
<span id="L251" class="LineNr">251 </span>          IndicatorsSetBy := r
<span id="L252" class="LineNr">252 </span>          resultis r
<span id="L253" class="LineNr">253 </span>     $)
<span id="L254" class="LineNr">254 </span>
<span id="L255" class="LineNr">255 </span><span class="Statement">and</span> TryMonadicRAR (Result, Op, Const) = valof
<span id="L256" class="LineNr">256 </span>     $(   unless IsSameLoc (Result, Lrand) resultis <span class="Constant">false</span>
<span id="L257" class="LineNr">257 </span>          let r = LoadNumber (Const, AorQr, <span class="Number">0</span>)
<span id="L258" class="LineNr">258 </span>          SetupAddr (Result)
<span id="L259" class="LineNr">259 </span>          Outop (FormOpcode (Op, r))
<span id="L260" class="LineNr">260 </span>          IndicatorsSetBy := <span class="Number">0</span>
<span id="L261" class="LineNr">261 </span>          RegisterUsage!r := <span class="Number">0</span>
<span id="L262" class="LineNr">262 </span>          resultis <span class="Constant">true</span>
<span id="L263" class="LineNr">263 </span>     $)
<span id="L264" class="LineNr">264 </span><span class="Statement">and</span> TryDiadicRAR (Result, Op) = valof
<span id="L265" class="LineNr">265 </span>     $(   let X = Rrand
<span id="L266" class="LineNr">266 </span>          unless IsSameLoc (Result, Lrand) <span class="Repeat">do</span>
<span id="L267" class="LineNr">267 </span>               $(   X := Lrand
<span id="L268" class="LineNr">268 </span>                    unless IsSameLoc (Result, Rrand) resultis <span class="Constant">false</span>
<span id="L269" class="LineNr">269 </span>               $)
<span id="L270" class="LineNr">270 </span>          <span class="Conditional">if</span> Op = Asa &amp; IsNumber (X) then <span class="Conditional">if</span> EvalNumber (X!<span class="Number">0</span>, X!<span class="Number">1</span>) = <span class="Number">1</span> <span class="Repeat">do</span>
<span id="L271" class="LineNr">271 </span>               $(   SetupAddr (Result)
<span id="L272" class="LineNr">272 </span>                    Outop (Aos)
<span id="L273" class="LineNr">273 </span>                    IndicatorsSetBy := <span class="Number">0</span>
<span id="L274" class="LineNr">274 </span>                    resultis <span class="Constant">true</span>
<span id="L275" class="LineNr">275 </span>               $)
<span id="L276" class="LineNr">276 </span>          let r = nil
<span id="L277" class="LineNr">277 </span>          test Op = Ssa &amp; X = Rrand
<span id="L278" class="LineNr">278 </span>          then r, Op := LoadNegative (X), Asa
<span id="L279" class="LineNr">279 </span>          or r := LoadRegister (X, AorQr)
<span id="L280" class="LineNr">280 </span>          SetupAddr (Result)
<span id="L281" class="LineNr">281 </span>          Outop (FormOpcode (Op, r))
<span id="L282" class="LineNr">282 </span>          IndicatorsSetBy := <span class="Number">0</span>
<span id="L283" class="LineNr">283 </span>          RegisterUsage!r := <span class="Number">0</span>
<span id="L284" class="LineNr">284 </span>          resultis <span class="Constant">true</span>
<span id="L285" class="LineNr">285 </span>     $)
<span id="L286" class="LineNr">286 </span>
<span id="L287" class="LineNr">287 </span><span class="Statement">and</span> IsSameLoc (t, u) = valof
<span id="L288" class="LineNr">288 </span>  switchon t!<span class="Number">0</span> into
<span id="L289" class="LineNr">289 </span>     $(   case LV_GLOBAL:
<span id="L290" class="LineNr">290 </span>                    resultis u!<span class="Number">0</span> = GLOBAL_S &amp; t!<span class="Number">1</span> = u!<span class="Number">1</span> -&gt; <span class="Constant">true</span>, <span class="Constant">false</span>
<span id="L291" class="LineNr">291 </span>          case LV_LOCAL:
<span id="L292" class="LineNr">292 </span>                    resultis u!<span class="Number">0</span> = LOCAL_S &amp; t!<span class="Number">1</span> = u!<span class="Number">1</span> -&gt; <span class="Constant">true</span>, <span class="Constant">false</span>
<span id="L293" class="LineNr">293 </span>          case LV_STATIC:
<span id="L294" class="LineNr">294 </span>                    resultis u!<span class="Number">0</span> = STATIC_S &amp; t!<span class="Number">1</span> = u!<span class="Number">1</span> -&gt; <span class="Constant">true</span>, <span class="Constant">false</span>
<span id="L295" class="LineNr">295 </span>          case TEMP_S:
<span id="L296" class="LineNr">296 </span>                    unless u!<span class="Number">0</span> = TEMP_S resultis <span class="Constant">false</span>
<span id="L297" class="LineNr">297 </span>                    let g, h = LookupTemp (t!<span class="Number">1</span>), LookupTemp (u!<span class="Number">1</span>)
<span id="L298" class="LineNr">298 </span>                    <span class="Conditional">if</span> g = <span class="Number">0</span> | h = <span class="Number">0</span> resultis <span class="Constant">false</span>
<span id="L299" class="LineNr">299 </span>                    unless g!<span class="Number">1</span> = LVECAP_S &amp; h!<span class="Number">1</span> = VECAP_S resultis <span class="Constant">false</span>
<span id="L300" class="LineNr">300 </span>                    resultis g!<span class="Number">2</span> = h!<span class="Number">2</span> &amp; g!<span class="Number">3</span> = h!<span class="Number">3</span> &amp; g!<span class="Number">5</span> = h!<span class="Number">5</span> &amp; g!<span class="Number">6</span> = h!<span class="Number">6</span> &amp; g!<span class="Number">8</span> = h!<span class="Number">8</span> -&gt; <span class="Constant">true</span>, <span class="Constant">false</span>
<span id="L301" class="LineNr">301 </span>          <span class="Constant">default</span>:  resultis <span class="Constant">false</span>
<span id="L302" class="LineNr">302 </span>     $)
<span id="L303" class="LineNr">303 </span>
<span id="L304" class="LineNr">304 </span><span class="Statement">and</span> DiadicJumpcond (Op, L) be
<span id="L305" class="LineNr">305 </span>     $(   let Reversed = valof switchon Op into
<span id="L306" class="LineNr">306 </span>               $(   case EQ_S: case NE_S: case LS_S: case GR_S: case LE_S: case GE_S:
<span id="L307" class="LineNr">307 </span>                              <span class="Conditional">if</span> IsZero (Rrand) <span class="Repeat">do</span>
<span id="L308" class="LineNr">308 </span>                                   $(   CompareToZero (Lrand)
<span id="L309" class="LineNr">309 </span>                                        resultis <span class="Constant">false</span>
<span id="L310" class="LineNr">310 </span>                                   $)
<span id="L311" class="LineNr">311 </span>                              <span class="Conditional">if</span> IsZero (Lrand) <span class="Repeat">do</span>
<span id="L312" class="LineNr">312 </span>                                   $(   CompareToZero (Rrand)
<span id="L313" class="LineNr">313 </span>                                        resultis <span class="Constant">true</span>
<span id="L314" class="LineNr">314 </span>                                   $)
<span id="L315" class="LineNr">315 </span>                              <span class="Conditional">if</span> InRegister (Rrand, AorQr) <span class="Repeat">do</span>
<span id="L316" class="LineNr">316 </span>                                   $(   ApplyRL (Cmpa, AorQr)
<span id="L317" class="LineNr">317 </span>                                        IndicatorsSetBy := <span class="Number">0</span>
<span id="L318" class="LineNr">318 </span>                                        resultis <span class="Constant">true</span>
<span id="L319" class="LineNr">319 </span>                                   $)
<span id="L320" class="LineNr">320 </span>                              ApplyLR (Cmpa, AorQr)
<span id="L321" class="LineNr">321 </span>                              IndicatorsSetBy := <span class="Number">0</span>
<span id="L322" class="LineNr">322 </span>                              resultis <span class="Constant">false</span>
<span id="L323" class="LineNr">323 </span>
<span id="L324" class="LineNr">324 </span>                    case EQ_F: case NE_F: case LS_F: case GR_F: case LE_F: case GE_F:
<span id="L325" class="LineNr">325 </span>                              <span class="Conditional">if</span> InRegister (Rrand, EAQr) <span class="Repeat">do</span>
<span id="L326" class="LineNr">326 </span>                                   $(   ApplyRL (Fcmp, EAQr)
<span id="L327" class="LineNr">327 </span>                                        IndicatorsSetBy := <span class="Number">0</span>
<span id="L328" class="LineNr">328 </span>                                        resultis <span class="Constant">true</span>
<span id="L329" class="LineNr">329 </span>                                   $)
<span id="L330" class="LineNr">330 </span>                              ApplyLR (Fcmp, EAQr)
<span id="L331" class="LineNr">331 </span>                              IndicatorsSetBy := <span class="Number">0</span>
<span id="L332" class="LineNr">332 </span>                              resultis <span class="Constant">false</span>
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>                    <span class="Constant">default</span>:  CGreport (UnexpectedCase, Op, <span class="String">&quot;DiadicJumpcond&quot;</span>)
<span id="L335" class="LineNr">335 </span>                              <span class="Statement">return</span>
<span id="L336" class="LineNr">336 </span>               $)
<span id="L337" class="LineNr">337 </span>
<span id="L338" class="LineNr">338 </span>          let t = valof switchon Op into
<span id="L339" class="LineNr">339 </span>               $(   case EQ_S: case EQ_F:         resultis Tze
<span id="L340" class="LineNr">340 </span>                    case NE_S: case NE_F:         resultis Tnz
<span id="L341" class="LineNr">341 </span>                    case LS_S: case LS_F:         resultis Reversed -&gt; Tpnz, Tmi
<span id="L342" class="LineNr">342 </span>                    case GR_S: case GR_F:         resultis Reversed -&gt; Tmi, Tpnz
<span id="L343" class="LineNr">343 </span>                    case LE_S: case LE_F:         resultis Reversed -&gt; Tpl, Tmoz
<span id="L344" class="LineNr">344 </span>                    case GE_S: case GE_F:         resultis Reversed -&gt; Tmoz, Tpl
<span id="L345" class="LineNr">345 </span>               $)
<span id="L346" class="LineNr">346 </span>
<span id="L347" class="LineNr">347 </span>          <span class="Conditional">if</span> Machine = <span class="Number">645</span> test t = Tmoz
<span id="L348" class="LineNr">348 </span>                    then $(   Outop2 (Tmi, L)
<span id="L349" class="LineNr">349 </span>                              t := Tze
<span id="L350" class="LineNr">350 </span>                         $)
<span id="L351" class="LineNr">351 </span>                    or <span class="Conditional">if</span> t = Tpnz <span class="Repeat">do</span>
<span id="L352" class="LineNr">352 </span>                         $(   Outop3 (Tze, <span class="Number">2</span>, Ic)
<span id="L353" class="LineNr">353 </span>                              t := Tpl
<span id="L354" class="LineNr">354 </span>                         $)
<span id="L355" class="LineNr">355 </span>          Outop2 (t, L)
<span id="L356" class="LineNr">356 </span>          DisclaimRegister (Lrand)
<span id="L357" class="LineNr">357 </span>          DisclaimRegister (Rrand)
<span id="L358" class="LineNr">358 </span>     $)
<span id="L359" class="LineNr">359 </span>
<span id="L360" class="LineNr">360 </span><span class="Statement">and</span> MonadicJumpcond (Op, L) be
<span id="L361" class="LineNr">361 </span>     $(   CompareToZero (Lrand)
<span id="L362" class="LineNr">362 </span>          Outop2 (Op = TRUE_S -&gt; Tnz, Tze, L)
<span id="L363" class="LineNr">363 </span>          DisclaimRegister (Lrand)
<span id="L364" class="LineNr">364 </span>     $)
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
